// DemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Demo.h"
#include "DemoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDemoDlg dialog

CDemoDlg::CDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDemoDlg)
	m_innerbevelbtn = 0;
	m_outerbevelbtn = 1;
	m_orientationbtn = 3;
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDemoDlg)
	DDX_Control(pDX, IDC_SLIDER4, m_outerbevelwidth);
	DDX_Control(pDX, IDC_SLIDER3, m_innerbevelwidth);
	DDX_Control(pDX, IDC_SLIDER2, m_borderwidth);
	DDX_Control(pDX, IDC_SLIDER1, m_pos);
	DDX_Control(pDX, ID_NEDGAUGE_OCX, m_gauge);
	DDX_Radio(pDX, IDC_RADIO_INNERBEVEL, m_innerbevelbtn);
	DDX_Radio(pDX, IDC_RADIO_OUTERBEVEL, m_outerbevelbtn);
	DDX_Radio(pDX, IDC_RADIO_ORIENTATION, m_orientationbtn);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CDemoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_RADIO_INNERBEVEL, OnRadioInnerbevel)
	ON_BN_CLICKED(IDC_RADIO_ORIENTATION, OnRadioOrientation)
	ON_BN_CLICKED(IDC_RADIO_OUTERBEVEL, OnRadioOuterbevel)
	ON_BN_CLICKED(IDC_RADIO9, OnRadio9)
	ON_BN_CLICKED(IDC_RADIO8, OnRadio8)
	ON_BN_CLICKED(IDC_RADIO6, OnRadio6)
	ON_BN_CLICKED(IDC_RADIO5, OnRadio5)
	ON_BN_CLICKED(IDC_RADIO4, OnRadio4)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio2)
	ON_BN_CLICKED(IDC_RADIO1, OnRadio1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDemoDlg message handlers

BOOL CDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_outerbevelwidth.SetRange(0, 10, TRUE);
	m_innerbevelwidth.SetRange(0, 10, TRUE);
	m_borderwidth.SetRange(0, 30, TRUE);
	m_pos.SetRange(0, 100, TRUE);

	m_outerbevelwidth.SetPageSize(1);
	m_innerbevelwidth.SetPageSize(1);
	m_borderwidth.SetPageSize(1);
	m_pos.SetPageSize(5);

	m_outerbevelwidth.SetPos(2);
	m_innerbevelwidth.SetPos(2);
	m_borderwidth.SetPos(3);
	m_pos.SetPos(50);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BEGIN_EVENTSINK_MAP(CDemoDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CDemoDlg)
	ON_EVENT(CDemoDlg, ID_NEDGAUGE_OCX, 1 /* Alarm */, OnAlarmNedgaugeOcx, VTS_PI2)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CDemoDlg::OnAlarmNedgaugeOcx(short FAR* Alarm) 
{
static BOOL bInAlarm = FALSE;

	if (!bInAlarm)
	{
		bInAlarm = TRUE;
		if (*Alarm == 1)
		{
			MessageBox("Low Alarm Hit!");
		}
		else
		{
			MessageBox("High Alarm Hit!");
		}

		bInAlarm = FALSE;
	}
}

void CDemoDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	if (SB_ENDSCROLL == nSBCode)
	{
		if (&m_outerbevelwidth == (CSliderCtrl *)pScrollBar)
		{
			m_gauge.SetOuterBevelWidth(((CSliderCtrl *)pScrollBar)->GetPos());
		}
		else if (&m_innerbevelwidth == (CSliderCtrl *)pScrollBar)
		{
			m_gauge.SetInnerBevelWidth(((CSliderCtrl *)pScrollBar)->GetPos());
		}
		else if (&m_borderwidth == (CSliderCtrl *)pScrollBar)
		{
			m_gauge.SetBorderWidth(((CSliderCtrl *)pScrollBar)->GetPos());
		}
		else
		{
			m_gauge.SetPos(((CSliderCtrl *)pScrollBar)->GetPos());
		}
	}
	
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CDemoDlg::OnRadioInnerbevel() 
{
	UpdateData();
	m_gauge.SetInnerBevel(m_innerbevelbtn);
}

void CDemoDlg::OnRadioOrientation() 
{
	UpdateData();
	m_gauge.SetOrientation(m_orientationbtn);
}

void CDemoDlg::OnRadioOuterbevel() 
{
	UpdateData();
	m_gauge.SetOuterBevel(m_outerbevelbtn);
}

void CDemoDlg::OnRadio9() 
{
	OnRadioInnerbevel();
}

void CDemoDlg::OnRadio8() 
{
	OnRadioInnerbevel();
}

void CDemoDlg::OnRadio6() 
{
	OnRadioOrientation();
}

void CDemoDlg::OnRadio5() 
{
	OnRadioOrientation();	
}

void CDemoDlg::OnRadio4() 
{
	OnRadioOrientation();	
}

void CDemoDlg::OnRadio2() 
{
	OnRadioOuterbevel();	
}

void CDemoDlg::OnRadio1() 
{
	OnRadioOuterbevel();	
}
